"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ModifiedVariant(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "modifiedVariant",
        "previousVariant",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "modifiedVariant": reports_4_2_0.ReportedVariant,
            "previousVariant": reports_4_2_0.ReportedVariant,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.ReportedVariant": reports_4_2_0.ReportedVariant,
            "org.gel.models.report.avro.ReportedVariant": reports_4_2_0.ReportedVariant,
            "org.gel.models.report.avro.ModifiedVariant": reports_4_2_0.ModifiedVariant,
        }

    __slots__ = [
        "modifiedVariant",
        "previousVariant",
    ]

    def __init__(
        self,
        modifiedVariant,
        previousVariant,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.ModifiedVariant model.

        :param modifiedVariant:
        :type modifiedVariant: ReportedVariant
        :param previousVariant:
        :type previousVariant: ReportedVariant
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
